=== qucs-transcalc/bitmaps/CMakeLists.txt ===

SET(XPMS )

SET(PNGS
c_microstrip.png
coax.png
microstrip.png
stripline.png
rectwaveguide.png
cpw.png
cpw_back.png)

SET(ICON )

INSTALL( FILES ${PNGS} DESTINATION share/qucs/bitmaps )
